// msg.cpp : implementation of the CMsg class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "msg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsg

IMPLEMENT_DYNCREATE(CMsg, CObject)
IMPLEMENT_SECSERIAL(CMsg)

/////////////////////////////////////////////////////////////////////////////
// CMsg construction/destruction

CMsg::CMsg()
{
	Init();
	IsNewUser=0;
	IsNewUserList=0;
	m_pUser = NULL;
	m_pUserList = NULL;
}

CMsg::~CMsg()
{
//	if(IsNewUser) delete m_pUser;
//	if(IsNewUserList) delete m_pUserList;
}

/////////////////////////////////////////////////////////////////////////////
// CMsg Operations

void CMsg::Init()
{
	m_bClose = FALSE;
	m_strText = _T("");
	m_msgList.RemoveAll();
}

void CMsg::SetHeader(int seq, int opt, CString receiver, CString sender){
	m_header.seq=seq;
	m_header.opt=opt;
	m_header.receiver=receiver;
	m_header.sender=sender;
}


/////////////////////////////////////////////////////////////////////////////
// CMsg serialization

void CMsg::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_header.seq;
		ar << m_header.opt;
		ar << m_header.receiver;
		ar << m_header.sender;
		ar << (WORD)m_bClose;
		if(m_header.opt == 2){
			if(m_pUser == NULL){
				AfxMessageBox("CMsg::Serialize error");
			}
			m_pUser->Serialize(ar);
		}else if( m_header.opt == 4){
			if(m_pUserList == NULL){
				AfxMessageBox("CMsg::Serialize error");
			}
			m_pUserList->Serialize(ar);
		}else if( m_header.seq == 0 || m_header.seq == 2){
			if(m_pNonce == NULL){
				AfxMessageBox("CMsg::Serialize error");
			}
			m_pNonce->Serialize(ar);
		}else if( m_header.seq == 1){
			if(m_pSessionKey == NULL){
				AfxMessageBox("CMsg::Serialize error");
			}
			m_pSessionKey->Serialize(ar);
		}else{
			ar << m_strText;
		}
	}
	else
	{
		WORD wd;
		ar >> m_header.seq;
		ar >> m_header.opt;
		ar >> m_header.receiver;
		ar >> m_header.sender;
		ar >> wd;
		m_bClose = (BOOL)wd;
		if(m_header.opt == 2){
			m_pUser=new COnlineUser;
			IsNewUser=1;
			m_pUser->Serialize(ar);
		}else if(m_header.opt == 4){
			m_pUserList = new COnlineUserList;
			IsNewUserList=1;
			m_pUserList->Serialize(ar);
		}else if(m_header.seq == 0 || m_header.seq == 2){
			m_pNonce = new CNonce;
			m_pNonce->Serialize(ar);
		}else if(m_header.seq == 1){
			m_pSessionKey = new CSessionKey;
			m_pSessionKey->Serialize(ar);
		}else{
			ar >> m_strText;
		}
	}
	m_msgList.Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CMsg diagnostics

#ifdef _DEBUG
void CMsg::AssertValid() const
{
	CObject::AssertValid();
}

void CMsg::Dump(CDumpContext& dc) const
{
	CObject::Dump(dc);
}
#endif //_DEBUG
