// msg.h : interface of the CMsg class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "sec\SecArchive.h"
#include "sec\rc6base.h"
#include "sec\data.h"

typedef struct{
	int seq;
	int opt;
	CString receiver;
	CString sender;
} THeader;

class CMsg : public CObject
{
protected:
	DECLARE_DYNCREATE(CMsg)
	DECLARE_SECSERIAL

public:
	CMsg();

// Attributes
public:
	THeader m_header;
	CString m_strText;
	BOOL m_bClose;
	CStringList m_msgList;
	COnlineUserList *m_pUserList;
	COnlineUser *m_pUser;
	CNonce *m_pNonce;
	CSessionKey *m_pSessionKey;
private:
	int IsNewUser;
	int IsNewUserList;

// Operations
public:
	void Init();
	void SetHeader(int seq, int opt, CString receiver, CString sender);

// Implementation
public:
	virtual ~CMsg();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

/////////////////////////////////////////////////////////////////////////////
