#include "stdafx.h"
#include "SecArchive.h"


/*
  Output file: (Encypted file)

      [0..3] bytes: number of blocks. (DWORD)
	  [4..7] bytes: Real message size in byte. (DWORD)
	                does not include the first 8 bytes.
*/
void CSecArchive::Output(void){
	m_pfileTemp->SeekToBegin();
	unsigned int nRealLength=m_pfileTemp->GetLength();
	unsigned int nNumBlock, nEncryptedLength;
	unsigned int i;
	nNumBlock = (nRealLength + m_nBlockSize - 1)/m_nBlockSize;
	nEncryptedLength = nNumBlock * m_nBlockSize;

	BYTE* data = new BYTE[nEncryptedLength];
	
	if(m_pfileTemp->ReadHuge(data, nRealLength) != nRealLength){
		AfxMessageBox("CFile::ReadHuge Error");
		return;
	}
	BYTE* ptr;
	for(i=0, ptr=data; i<nEncryptedLength; i+=m_nBlockSize, ptr+=m_nBlockSize){
		m_pCipher->Encrypt(ptr, m_nBlockSize);
	}
	(*m_parFile) << nNumBlock;
	(*m_parFile) << nRealLength;
	m_parFile->Write(data, nEncryptedLength);
	delete[] data;
}

void CSecArchive::Input(void){
	unsigned int nRealLength;
	unsigned int nNumBlock, nEncryptedLength;
	unsigned int i;

	(*m_parFile) >> nNumBlock;
	(*m_parFile) >> nRealLength;
	nEncryptedLength=nNumBlock*m_nBlockSize;

	BYTE* data = new BYTE[nEncryptedLength];

	if(m_parFile->Read(data, nEncryptedLength)!=nEncryptedLength){
		AfxMessageBox("CArchive::Read Error");
		return;
	}

	BYTE* ptr;
	for(i=0, ptr=data; i<nEncryptedLength; i+=m_nBlockSize, ptr+=m_nBlockSize){
		m_pCipher->Decrypt(ptr, m_nBlockSize);
	}
	m_pfileTemp->WriteHuge(data, nRealLength);
	delete[] data;
}