// UserInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "chatsrvr.h"
#include "UserInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUserInfoDlg dialog


CUserInfoDlg::CUserInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserInfoDlg)
	m_strID = _T("");
	m_strName = _T("");
	m_strOthers = _T("");
	//}}AFX_DATA_INIT
	m_pdibPic=NULL;
}


void CUserInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserInfoDlg)
	DDX_Control(pDX, IDC_USERLIST, m_UserList);
	DDX_Text(pDX, IDC_ID, m_strID);
	DDX_Text(pDX, IDC_NAME, m_strName);
	DDX_Text(pDX, IDC_OTHERS, m_strOthers);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CUserInfoDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_USERLIST, OnItemchangedUserlist)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUserInfoDlg message handlers

extern CUserList UserList;

BOOL CUserInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	if(UserList.IsEmpty()) return TRUE;

	CUserInfo* ui;
	int i;
	m_imageList.Create(16, 16, 0, 0, UserList.GetCount());
	CListCtrl* pList=(CListCtrl*) GetDlgItem(IDC_USERLIST);
	for(i=0, ui=UserList.First(); ui!=NULL; ui=UserList.Next(), i++){
		HICON hIcon;
		if(ui->m_nMale == 1)
			hIcon=AfxGetApp()->LoadIcon(IDI_GIRL);
		else
			hIcon=AfxGetApp()->LoadIcon(IDI_BOY);
		m_imageList.Add(hIcon);
		pList->InsertItem(i, ui->m_strID, i);
	}
	pList->SetImageList(&m_imageList, LVSIL_SMALL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

extern CUserList UserList;

void CUserInfoDlg::OnItemchangedUserlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	CListCtrl* pList = (CListCtrl*) GetDlgItem(IDC_USERLIST);
	int nSelected = pNMListView->iItem;
	if(nSelected>=0){
		CString strItem=pList->GetItemText(nSelected, 0);
		CUserInfo *ui;
		ui = UserList.Find(strItem);
		if(ui==NULL){
			AfxMessageBox("OnItemchangedUserlist(...) error!");
			return;
		}
		m_strID = ui->m_strID;
		m_strName = ui->m_strName;
		m_strOthers = ui->m_strOthers;
		m_pdibPic = &(ui->m_dibPic);
		UpdateData(FALSE);

		CWnd* pWnd=GetDlgItem(IDC_PIC);
		CDC* pdc = pWnd->GetDC();
		pWnd->Invalidate();
		pWnd->UpdateWindow();
		m_pdibPic->Draw(pdc, CPoint(0, 0), CSize(50,50));
		pWnd->ReleaseDC(pdc);
	}
	*pResult = 0;
}

void CUserInfoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if(m_pdibPic==NULL) return;
	CWnd* pWnd=GetDlgItem(IDC_PIC);
	CDC* pdc = pWnd->GetDC();
	pWnd->Invalidate();
	pWnd->UpdateWindow();
	m_pdibPic->Draw(pdc, CPoint(0, 0), CSize(50,50));
	pWnd->ReleaseDC(pdc);
	
	// Do not call CDialog::OnPaint() for painting messages
}
