// mainfrm.cpp : implementation of the CMainFrame class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "chatsrvr.h"

#include "mainfrm.h"
#include "AddUserDlg.h"
#include "UserInfoDlg.h"
#include "GenKeyDlg.h"
#include "Sec\data.h"
#include <direct.h>
#include <stdio.h>
#include <io.h>
#include "sec\RC6Base.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern CUserList UserList;
extern char WorkDir[255];
//extern CKeyList KeyList;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_USER_ADDUSER, OnUserAdduser)
	ON_COMMAND(ID_USER_ALLUSERS, OnUserAllusers)
	ON_COMMAND(ID_USER_GENKEY, OnUserGenkey)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars
	
// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_CONNECTIONS,
	ID_MESSAGES,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

#ifdef _WIN32
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);
#endif

	if(_chdir(WorkDir) == -1){
		AfxMessageBox("Working Directory doesn't exist!");
		return 0;
	}
	if(_chdir(KEYDIRECTORY) == -1){
		if(_mkdir(KEYDIRECTORY) == -1){
			AfxMessageBox("Error to open directroy for keys");
			return 0;
		}
		_chdir(KEYDIRECTORY);
	}
	CFile file;
	BYTE key[16] = LOCAL_KEY;
	CRC6Base rc6;
	if(file.Open(USERINFO_FILE, CFile::modeRead) != 0){
		CSecArchive ar(&rc6, &file, CArchive::load);
		UserList.SecSerialize(ar, key, 16);
		ar.Close();
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnUserAdduser() 
{
	// TODO: Add your command handler code here
	CAddUserDlg dlg;
	if(dlg.DoModal() != IDOK) return;

	CUserInfo* ui;
	ui = new CUserInfo;

	if(ui->SetInfo(dlg.m_strID, dlg.m_strName, 
		dlg.m_nMale, dlg.m_strOthers, dlg.m_strPic) == 0) return;

    struct _finddata_t c_file;
	if(_findfirst(dlg.m_strKey, &c_file) == -1L ){
		AfxMessageBox("Public Key File not found!");
		return;
	}
	if(_chdir(WorkDir) == -1){
		AfxMessageBox("Working Directory doesn't exist!");
		return;
	}
	if(_chdir(KEYDIRECTORY) == -1){
		if(_mkdir(KEYDIRECTORY) == -1){
			AfxMessageBox("Error to open directroy for keys");
			return;
		}
		_chdir(KEYDIRECTORY);
	}

	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return;
	}

	if(pUserRSA->LoadFile((unsigned char*)(LPCTSTR)dlg.m_strKey) != S_OK){
		AfxMessageBox("Public Key File format error!");
		return;
	}
	pUserRSA->SavePublicKey((unsigned char*)(LPCTSTR)dlg.m_strID);
	//KeyList.Add(dlg.m_strID, pUserRSA);
	_chdir("..");

	UserList.Add(ui);
}

void CMainFrame::OnUserAllusers() 
{
	// TODO: Add your command handler code here
	CUserInfoDlg dlg;
	dlg.DoModal();
}

void CMainFrame::OnUserGenkey() 
{
	// TODO: Add your command handler code here
	CGenKeyDlg dlg;
	if(dlg.DoModal()!=IDOK) return;
	IUserRSA* pUserRSA;
	HRESULT hr = CoCreateInstance(CLSID_UserRSA,
	NULL, 
	CLSCTX_INPROC_SERVER, 
	IID_IUserRSA, 
	(void **)&pUserRSA);
	if(hr==REGDB_E_CLASSNOTREG){
		AfxMessageBox("REGDB_E_CLASSNOTREG ");
	}
	if(hr==CLASS_E_NOAGGREGATION){
		AfxMessageBox("CLASS_E_NOAGGREGATION ");
	}
	if(FAILED(hr)){
		AfxMessageBox("IUserRSA failed");
		return;
	}

	pUserRSA->Generate((unsigned char*)(LPCTSTR)dlg.m_strID, 32);
	if(_chdir(WorkDir) == -1){
		AfxMessageBox("Working Directory doesn't exist!");
		return;
	}
	if(_chdir(NEWKEYDIR) == -1){
		if(_mkdir(NEWKEYDIR) == -1){
			AfxMessageBox("Error to open directroy for keys");
			return;
		}
		_chdir(NEWKEYDIR);
	}
	if(_chdir(dlg.m_strID) == -1){
		if(_mkdir(dlg.m_strID) == -1){
			AfxMessageBox("Error to open directroy for keys");
			return;
		}
		_chdir(dlg.m_strID);
	}
	remove("public.key");
	remove("private.key");
	unsigned char pub[20]="public.key";
	unsigned char pri[20]="private.key";
	pUserRSA->SavePublicKey(pub);
	pUserRSA->SavePrivateKey(pri);
	_chdir("..");
	_chdir("..");
	pUserRSA->Release();
	CString textout;
	textout.Format("Key Generation Complete!\nYour Keys in:\n  %s\\%s\\public.key\n  %s\\%s\\private.key",
		            NEWKEYDIR, dlg.m_strID, NEWKEYDIR, dlg.m_strID);
	AfxMessageBox(textout);
}

void CMainFrame::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(_chdir(WorkDir) == -1){
		AfxMessageBox("Working Directory doesn't exist!");
		CFrameWnd::OnClose();
		return;
	}
	if(_chdir(KEYDIRECTORY) == -1){
		if(_mkdir(KEYDIRECTORY) == -1){
			AfxMessageBox("Error to open directroy for keys");
			CFrameWnd::OnClose();
			return;
		}
		_chdir(KEYDIRECTORY);
	}
	CFile file;
	BYTE key[16] = LOCAL_KEY;
	CRC6Base cipher;
	if(file.Open(USERINFO_FILE, CFile::modeCreate | CFile::modeWrite) != 0){
		CSecArchive ar(&cipher, &file, CArchive::store);
		UserList.SecSerialize(ar, key, 16);
		ar.Close();
	}

	CFrameWnd::OnClose();
}
